﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Security.Cryptography;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Net;
using System;  
using System.Collections.Generic;  
using System.Linq;  
using System.Text;  
using System.Net.Security;  
using System.Security.Cryptography.X509Certificates;  
using System.DirectoryServices.Protocols; 
using System.ServiceModel.Security;  
using System.Net;  
using System.IO;  
using System.IO.Compression;  
using System.Text.RegularExpressions;

public partial class httpPost : System.Web.UI.Page
{

    private static readonly string DefaultUserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.2; SV1; .NET CLR 1.1.4322; .NET CLR 2.0.50727)";  

    private static String URL = "https://mertest.chinapnr.com/pay/receivermb.htm";

    protected void Page_Load(object sender, EventArgs e)
    {

        string inputCharset = Request["inputCharset"].ToString();
        string pageUrl = Request.Params["pageUrl"].ToString();
        string bgUrl = Request.Params["bgUrl"].ToString();
        string language = Request.Params["language"].ToString();
        string signType = Request.Params["signType"].ToString();
        string signMsg = Request.Params["signMsg"].ToString();
        string version = Request.Params["version"].ToString();
        string merchantAcctId = Request.Params["merchantAcctId"].ToString();
        string terminalId = Request.Params["terminalId"].ToString();

        String payerName = Request.Params["payerName"].ToString();
        String payerContactType = Request.Params["payerContactType"].ToString();
        String payerContact = Request.Params["payerContact"].ToString();
        String payerIdentityCard = Request.Params["payerIdentityCard"].ToString();
        String mobileNumber = Request.Params["mobileNumber"].ToString();
        String cardNumber = Request.Params["cardNumber"].ToString();

        String orderId = Request.Params["orderId"].ToString();
        String orderAmount = Request.Params["orderAmount"].ToString();
        String orderTime = Request.Params["orderTime"].ToString();
        String orderCurrency = Request.Params["orderCurrency"].ToString();
        String refererUrl = Request.Params["refererUrl"].ToString();
        String customerIp = Request.Params["customerIp"].ToString();
        String orderTimeout = Request.Params["orderTimeout"].ToString();

        String productName = Request.Params["productName"].ToString();
        String productNum = Request.Params["productNum"].ToString();
        String productId = Request.Params["productId"].ToString();
        String productDesc = Request.Params["productDesc"].ToString();
        String payType = Request.Params["payType"].ToString();
        String bankId = Request.Params["bankId"].ToString();

        string ext1 = "";
        if (Request.Params["ext1"] != null)
        {
            ext1 = Request.Params["ext1"].ToString();
        }

        //扩展字段2，该值与提交时相同。
        string ext2 = "";
        if (Request.Params["ext2"] != null)
        {
            ext2 = Request.Params["ext2"].ToString();
        }
        ;

        Encoding encoding = Encoding.GetEncoding("utf-8");

        IDictionary<string, string> parameters = new Dictionary<string, string>();
        parameters.Add("inputCharset", inputCharset);
        parameters.Add("pageUrl", pageUrl);
        parameters.Add("bgUrl", bgUrl);
        parameters.Add("language", language);
        parameters.Add("signType", signType);
        parameters.Add("signMsg", signMsg);
        parameters.Add("version", version);
        parameters.Add("merchantAcctId", merchantAcctId);
        parameters.Add("terminalId", terminalId);

        parameters.Add("payerName", payerName);
        parameters.Add("payerContactType", payerContactType);
        parameters.Add("payerContact", payerContact);
        parameters.Add("payerIdentityCard", payerIdentityCard);
        parameters.Add("mobileNumber", mobileNumber);
        parameters.Add("cardNumber", cardNumber);

        parameters.Add("orderId", orderId);
        parameters.Add("orderAmount", orderAmount);
        parameters.Add("orderTime", orderTime);
        parameters.Add("orderCurrency", orderCurrency);
        parameters.Add("refererUrl", refererUrl);
        parameters.Add("customerIp", customerIp);
        parameters.Add("orderTimeout", orderTimeout);

        parameters.Add("productName", productName);
        parameters.Add("productNum", productNum);
        parameters.Add("productId", productId);
        parameters.Add("productDesc", productDesc);
        parameters.Add("ext1", ext1);
        parameters.Add("ext2", ext2);
        parameters.Add("payType", payType);
        parameters.Add("bankId", bankId);

        HttpWebResponse response = CreatePostHttpResponse(URL, parameters, null, null, encoding, null);

        if (response.StatusCode == HttpStatusCode.OK)
        {
            System.IO.Stream responseStream = response.GetResponseStream();
            System.IO.StreamReader reader = new System.IO.StreamReader(responseStream, Encoding.UTF8);
            string respTxt = reader.ReadToEnd();
            if (respTxt.Length==0)
            {
                Response.Write("网关系统异常,返回内容为空");
                return;
            }
            if (respTxt.Contains("errCode"))
            {
                Response.Write("置单失败,返回内容=[" + respTxt + "]");
                return;
            }
            Response.Redirect(HttpUtility.UrlDecode(respTxt));
            return;
        }
        Response.Write("网关系统异常,返回码[" + response.StatusCode + "]");

        string cookieString = response.Headers["Set-Cookie"];

    }

    /// <summary>  
    /// 创建POST方式的HTTP请求  
    /// </summary>  
    /// <param name="url">请求的URL</param>  
    /// <param name="parameters">随同请求POST的参数名称及参数值字典</param>  
    /// <param name="timeout">请求的超时时间</param>  
    /// <param name="userAgent">请求的客户端浏览器信息，可以为空</param>  
    /// <param name="requestEncoding">发送HTTP请求时所用的编码</param>  
    /// <param name="cookies">随同HTTP请求发送的Cookie信息，如果不需要身份验证可以为空</param>  
    /// <returns></returns>  
    public static HttpWebResponse CreatePostHttpResponse(string url, IDictionary<string, string> parameters, int? timeout, string userAgent, Encoding requestEncoding, CookieCollection cookies)
    {
        if (string.IsNullOrEmpty(url))
        {
            throw new ArgumentNullException("url");
        }
        if (requestEncoding == null)
        {
            throw new ArgumentNullException("requestEncoding");
        }
        HttpWebRequest request = null;
        //如果是发送HTTPS请求  
        if (url.StartsWith("https", StringComparison.OrdinalIgnoreCase))
        {
            ServicePointManager.ServerCertificateValidationCallback = new RemoteCertificateValidationCallback(CheckValidationResult);
            request = WebRequest.Create(url) as HttpWebRequest;
            request.ProtocolVersion = HttpVersion.Version10;
        }
        else
        {
            request = WebRequest.Create(url) as HttpWebRequest;
        }
        request.Method = "POST";
        request.ContentType = "application/x-www-form-urlencoded";

        if (!string.IsNullOrEmpty(userAgent))
        {
            request.UserAgent = userAgent;
        }
        else
        {
            request.UserAgent = DefaultUserAgent;
        }

        if (timeout.HasValue)
        {
            request.Timeout = timeout.Value;
        }
        if (cookies != null)
        {
            request.CookieContainer = new CookieContainer();
            request.CookieContainer.Add(cookies);
        }
        //如果需要POST数据  
        if (!(parameters == null || parameters.Count == 0))
        {
            StringBuilder buffer = new StringBuilder();
            int i = 0;
            foreach (string key in parameters.Keys)
            {
                if (i > 0)
                {
                    buffer.AppendFormat("&{0}={1}", key, parameters[key]);
                }
                else
                {
                    buffer.AppendFormat("{0}={1}", key, parameters[key]);
                }
                i++;
            }
            var postData = string.Join("&", parameters.Select(
                p => string.Format("{0}={1}", p.Key, System.Web.HttpUtility.UrlEncode(p.Value, requestEncoding))).ToArray());

            byte[] data = requestEncoding.GetBytes(postData);
            using (Stream stream = request.GetRequestStream())
            {
                stream.Write(data, 0, data.Length);
            }
        }
        return request.GetResponse() as HttpWebResponse;
    }

    private static bool CheckValidationResult(object sender, X509Certificate certificate, X509Chain chain, SslPolicyErrors errors)
    {
        return true; //总是接受  
    }  
}